/* Human error rules for message sending confusion */
rule E_msc:
  [ Fail($A,'msc'), !HK($A,m2), Snd(p,$A,$B,<cid,m1>) ] --[ Human($A), Failed($A) ]-> [ Snd(p,$A,$B,<cid,m2>) ]

/* Human error rules for channel sending confusion */
rule E_csc:
  [ Fail($A,'csc'), Snd(p1,$A,$B,m1), Snd(p2,$A,$C,m2) ] --[ Human($A), Failed($A) ]-> [ Snd(p1,$A,$B,m1), Snd(p2,$A,$C,m1) ]

/* Human error rules for message receiving confusion */
rule E_mrc_1:
  [ Fail($A,'mrc'), Rcv(p,$B,$A,m1) ] --[ Human($A), Failed($A) ]-> [ Rcv(p,$B,$A,$m2) ]
rule E_mrc_2:
  [ Fail($A,'mrc'), Rcv(p,$B,$A,m1), Fr(m2) ] --[ Human($A), Failed($A) ]-> [ Rcv(p,$B,$A,m2) ]

/* Human error rules for no learning confusion */
rule E_nlc:
  [ Fail($A,'nlc'), Rcv(p,$B,$A,m1), Fr(m2) ] --[ Human($A), Failed($A) ]-> [ Rcv(p,$B,$A,m2) ]

/* Human error rules for channel receiving confusion */
rule E_crc:
  [ Fail($A,'crc'), Rcv(p1,$B,$A,<n1,m1>), Rcv(p2,$C,$A,<n2,m2>) ] --[ Human($A), Failed($A) ]-> [ Rcv(p1,$B,$A,<n1,m2>), Rcv(p2,$C,$A,<n2,m1>) ]

/* Human error rules for ignoring comparison confusion */
rule E_icc:
  [ Fail($A,'icc'), Compare($A,m1,m2)] --[ Human($A), Failed($A) ]-> [ Verified($A,m1,m2) ]

/* Human error rules for weak randomness confusion */
rule E_wrc:
  [ Fail($A,'wrc') ] --[ Human($A), Failed($A) ]-> [ Fresh($A,$m) ]

/* Human error rules for step order confusion (and ignoring a non-blocking protocol step) */
// Note that for this rule corresponding computer agents need to fail as well (Sysfail facts!)
rule E_soc:
  [ Fail($A,'soc'), AgentState($A,c1,n), !HK($A,c2) ] --[ Human($A), Failed($A) ]-> [ AgentState($A,c2,n) ]

/* Human error rules for step repetition confusion */
// Note that for this rule corresponding computer agents need to fail as well (Sysfail facts!)
rule E_src:
  [ Fail($A,'src'), AgentState($A,c,n) ] --[ Human($A), Failed($A) ]-> [ AgentState($A,c,n), AgentState($A,c,n) ]

/* Human knowledge rules for concatenation, selection and generation confusion, respectively */
rule E_kcc:
  [ Fail($A,'kcc'), !HK($A,m1), !HK($A,m2) ] --[ Human($A), Failed($A) ]-> [ !HK($A,<m1,m2>) ]
rule E_ksc:
  [ Fail($A,'ksc'), !HK($A,<m1,m2>) ] --[ Human($A), Failed($A) ]-> [ !HK($A,m1), !HK($A,m2) ]
rule E_kgc:
  [ Fail($A,'kgc') ] --[ Human($A), Failed($A) ]-> [ !HK($A,$m) ]
